data:extend(
{
  {
    type = "item",
    name = "heat-furnace",
    icon = "__base__/graphics/icons/electric-furnace.png",
    icon_size = 64,
    icon_mipmaps = 4,
    subgroup = "smelting-machine",
    order = "c[heat-furnace-1]",
    place_result = "heat-furnace",
    stack_size = 50
  },
  {
    type = "recipe",
    name = "heat-furnace",
    ingredients =
    {
    },
    result = "heat-furnace"
  },

util.merge{data.raw.furnace["electric-furnace"],
  {
    name = "heat-furnace",
    minable = {result = "heat-furnace"},
  }
}

}
)

data.raw.furnace["heat-furnace"].energy_source = data.raw.boiler["heat-exchanger"].energy_source
data.raw.furnace["heat-furnace"].energy_source.connections =
  {
    { position = {-1, -1}, direction = defines.direction.west },
    { position = {1, -1}, direction = defines.direction.east }
  }



local function layers_check(animation)
  if not animation.layers then
    return {layers = {animation}}
  else
    return animation
  end
end

local function get_4_way_animation_with_layers(animation)
  if animation.north then
    local new_animation = util.table.deepcopy(animation)
    new_animation.north = layers_check(new_animation.north)
    if not new_animation.south then
      new_animation.south = util.table.deepcopy(new_animation.north)
    end
    new_animation.south = layers_check(new_animation.south)
    if not new_animation.east then
      if new_animation.west then
        new_animation.east = util.table.deepcopy(new_animation.west)
      else
        new_animation.east = util.table.deepcopy(new_animation.north)
      end
    end
    new_animation.east = layers_check(new_animation.east)
    if not new_animation.west then
      new_animation.west = util.table.deepcopy(new_animation.east)
    end
    new_animation.west = layers_check(new_animation.west)
    return new_animation
  else
    return
    {
      north = layers_check(util.table.deepcopy(animation)),
      east = layers_check(util.table.deepcopy(animation)),
      south = layers_check(util.table.deepcopy(animation)),
      west = layers_check(util.table.deepcopy(animation))
    }
  end
end

local function add_heat_pipe(animation, tier)
  local furnace_animation = get_4_way_animation_with_layers(animation)
    table.insert(furnace_animation.north.layers, 1, {
      filename = "__bobsimpletest__/graphics/entity/heat-pipe/hr-heat-pipe-3-n-" .. tier .. ".png",
      priority = "high",
      width = 192,
      height = 192,
      frame_count = 1,
      scale = 0.5
    }
    )
    table.insert(furnace_animation.east.layers, 1, {
      filename = "__bobsimpletest__/graphics/entity/heat-pipe/hr-heat-pipe-3-e-" .. tier .. ".png",
      priority = "high",
      width = 192,
      height = 192,
      frame_count = 1,
      scale = 0.5
    }
    )
    table.insert(furnace_animation.south.layers, 1, {
      filename = "__bobsimpletest__/graphics/entity/heat-pipe/hr-heat-pipe-3-s-" .. tier .. ".png",
      priority = "high",
      width = 192,
      height = 192,
      frame_count = 1,
      scale = 0.5
    }
    )
    table.insert(furnace_animation.west.layers, 1, {
      filename = "__bobsimpletest__/graphics/entity/heat-pipe/hr-heat-pipe-3-w-" .. tier .. ".png",
      priority = "high",
      width = 192,
      height = 192,
      frame_count = 1,
      scale = 0.5
    }
    )
  return furnace_animation
end

data.raw.furnace["heat-furnace"].animation = add_heat_pipe(data.raw.furnace["electric-furnace"].animation, 1)
